# ----------------------------------------------------------------------------
# Csound Tcl Partitur-Skript   "Experiment II"                     NOV-21-2002
# Copyright (c) 2002 by Hartmut Schwarz               matut@matut-spielwerk.de
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2 
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the Free
# Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA 02111-1307, USA.
#
# ----------------------------------------------------------------------------

# ------------------------------------ ins Tcl-Arbeitsverzeichnis wechseln ---
cd "[file dirname $argv0]/..";

# ------------------------------------------- allgemeine Grundlagen lernen ---
source "basics/ref.tcl";   # alles ueber Referenzvariablen
source "basics/tree.tcl";  # alles ueber Datenbaeume

# --------------------------------- die Grundlagen der Csound-Musik lernen ---
source "basics/music.tcl";

# ------------------------------------------------------ das Spiel beginnt ---
set root [plant]; # einen neuen Klangbaum pflanzen

# Experiment II : Spiel mit natrlichen Intervallen
set stem [TREEnew $root {vlbs 76 chbt ./././._/./.__/._ idst 60}];
sprout $stem\
 {song {} vars {\
  {tmtv 4.0 kybs {[global KBASE264;\
                   expr [set KBASE264]+[get_key_by_ratio 8:3]]}}\
  {tmtv 2.8 kybs {[global KBASE264;\
                   expr [set KBASE264]+[get_key_by_ratio 10:3]]}}\
  {tmtv 2.3 kybs {[global KBASE264;\
                   expr [set KBASE264]+[get_key_by_ratio 12:3]]}}\
  {tmtv 2.0 kybs {[global KBASE264;\
                   expr [set KBASE264]+[get_key_by_ratio 14:3]]}}\
  {tmtv 1.8 kybs {[global KBASE264;\
                   expr [set KBASE264]+[get_key_by_ratio 16:3]]}}\
  {tmtv 2.0 kybs {[global KBASE264;\
                   expr [set KBASE264]+[get_key_by_ratio 14:3]]}}\
  {tmtv 2.3 kybs {[global KBASE264;\
                   expr [set KBASE264]+[get_key_by_ratio 12:3]]}}\
  {tmtv 2.8 kybs {[global KBASE264;\
                   expr [set KBASE264]+[get_key_by_ratio 10:3]]}}\
  {tmtv 4.0 kybs {[global KBASE264;\
                   expr [set KBASE264]+[get_key_by_ratio 8:3]]}}\
 }}\
 {csym (1:1,2:1)\
  cmod ..\
  kybs {[expr [STEM kybs]-[get_key_by_ratio 16:3]]}}\
 {csym (2:2,3:2,4:2)/(1:1,2:1)\
  cmod r.'.'./..\
  kybs {[expr [STEM kybs]-[get_key_by_ratio 12:3]]}}\
 {csym (3:3,4:3,5:3,6:3)/(2:2,3:2,4:2)/(1:1,2:1)\
  cmod .'.''.'./r.'.'./..\
  kybs {[expr [STEM kybs]-[get_key_by_ratio 8:3]]}}\
 {csym (4:4,5:4,6:4,7:4,8:4)/(3:3,4:3,5:3,6:3)/(2:2,3:2,4:2)/(1:1,2:1)\
  cmod r.'.'.'.'./.'.''.'./r.'.'./..\
  kybs {[expr [STEM kybs]-[get_key_by_ratio 4:3]]}}\
 {csym {(5:5,6:5,7:5,8:5,9:5,10:5)/(4:4,5:4,6:4,7:4,8:4)\
       /(3:3,4:3,5:3,6:3)/(2:2,3:2,4:2)/(1:1,2:1)}\
  cmod .'.'.''.'.'./r.'.'.'.'./.'.''.'./r.'.'./..\
  kybs {[expr [STEM kybs]-[get_key_by_ratio 2:3]]}}\
 {rept 18 more {\
  {song {} vars {\
   {cmod '''''......./r''''....../'''...../r''..../',../r..\
    kybs {[expr [STEM kybs]-[get_key_by_ratio 4:3]]}}\
   {cmod r''''......./'''....../r''...../'..../r.,./..\
    kybs {[expr [STEM kybs]-[get_key_by_ratio 4:3]]}}\
   {cmod {'''......./r''....../'.....\
         /r..../,../r..}\
    kybs {[expr [STEM kybs]-[get_key_by_ratio 2:3]]}}\
   {cmod {r''......./'....../r.....\
         /..../r.,./..}\
    kybs {[expr [STEM kybs]-[get_key_by_ratio 2:3]]}}\
   {cmod '......./....../...../..../.../..\
    kybs {[expr [STEM kybs]-[get_key_by_ratio 1:3]]}}\
   {cmod {r''......./'....../r.....\
         /..../r.,./..}\
    kybs {[expr [STEM kybs]-[get_key_by_ratio 2:3]]}}\
   {cmod {'''......./r''....../'.....\
         /r..../,../r..}\
    kybs {[expr [STEM kybs]-[get_key_by_ratio 2:3]]}}\
   {cmod r''''......./'''....../r''...../'..../r.,./../\
    kybs {[expr [STEM kybs]-[get_key_by_ratio 4:3]]}}\
   {cmod '''''......./r''''....../'''...../r''..../',../r..\
    kybs {[expr [STEM kybs]-[get_key_by_ratio 4:3]]}}\
  }}\
  {csym {(6:6,7:6,8:6,9:6,10:6,11:6,12:6)/(5:5,6:5,7:5,8:5,9:5,10:5)\
        /(4:4,5:4,6:4,7:4,8:4)/(3:3,4:3,5:3,6:3)/(2:2,3:2,4:2)/(1:1,2:1)}\
  }\
 }}\
 {csym {(5:5,6:5,7:5,8:5,9:5,10:5)/(4:4,5:4,6:4,7:4,8:4)/(3:3,4:3,5:3,6:3)\
       /(2:2,3:2,4:2)/(1:1,2:1)}\
  cmod r.'.'.''.'.'./.'.'.'.'./r.'.''.'./.'.'./r..\
  kybs {[expr [STEM kybs]-[get_key_by_ratio 2:3]]}}\
 {csym (4:4,5:4,6:4,7:4,8:4)/(3:3,4:3,5:3,6:3)/(2:2,3:2,4:2)/(1:1,2:1)\
  cmod .'.'.'.'./r.'.''.'./.'.'./r..\
  kybs {[expr [STEM kybs]-[get_key_by_ratio 4:3]]}}\
 {csym (3:3,4:3,5:3,6:3)/(2:2,3:2,4:2)/(1:1,2:1)\
  cmod r.'.''.'./.'.'./r..\
  kybs {[expr [STEM kybs]-[get_key_by_ratio 8:3]]}}\
 {csym (2:2,3:2,4:2)/(1:1,2:1)\
  cmod .'.'./r..\
  kybs {[expr [STEM kybs]-[get_key_by_ratio 12:3]]}}\
 {csym (1:1,2:1)\
  cmod r..\
  kybs {[expr [STEM kybs]-[get_key_by_ratio 16:3]]}}\
 ;
begin $root "[file rootname [file tail $argv0]]" 0.5;
touch $stem 261;
end $root 2.0;
