# ----------------------------------------------------------------------------
# Csound Tcl Partitur-Skript      "Die Gedanken sind frei"         JAN-13-2004
# Copyright (c) 2004 by Hartmut Schwarz               matut@matut-spielwerk.de
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2 
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the Free
# Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA 02111-1307, USA.
#
# ----------------------------------------------------------------------------

# ------------------------------------ ins Tcl-Arbeitsverzeichnis wechseln ---
cd "[file dirname $argv0]/..";

# ------------------------------------------- allgemeine Grundlagen lernen ---
source "basics/ref.tcl";   # alles ueber Referenzvariablen
source "basics/tree.tcl";  # alles ueber Datenbaeume

# --------------------------------- die Grundlagen der Csound-Musik lernen ---
source "basics/music.tcl";

# ------------------------------------------------------ das Spiel beginnt ---
set root [plant]; # einen neuen Klangbaum pflanzen
# Titel
set stem [TREEnew $root {chtv 2 chbt ./././././fff. kybs 29 vlbs 77}];
sprout $stem\
{csym (11,12,14,16)/(11,12,14,16)/(11,12,14,16)/(11,12,14,16)/(11,12,14,16)/(11,12,14,16) 
 cmod ;/'.''.'.'..'./'.''.'.'..'./u'.''.'.'..'./u'.''.'.'..'./u'.''.'.'..'.
 chbt ;/......../....../..../../.}\
{csym (7,9,12)/(7,9,12)/(7,9,12)/(7,9,12)/(7,9,12)/(7,9,12)
 cmod ;/r..''.'.../r..''.'.../ur..''.'.../ur..''.'.../ur..''.'...
 chbt ;/......../....../..../../.}\
{csym (11,12,14,16)/(11,12,14,16)/(11,12,14,16)/(11,12,14,16)/(11,12,14,16)/(11,12,14,16) 
 cmod ;/;/;/u,,'./;/u..'.}\
{csym (11,12,14,16)/(11,12,14,16)/(11,12,14,16)/(11,12,14,16)/(11,12,14,16)/(11,12,14,16) 
 cmod ;/;/u,,./;/;/u'.''.'.}\
\
{csym (0,4,7)/(0,2,4,5,7)/(0,4,7)/(0,4,7)/(0,4,7)/(0,4,7)
 cmod ;/;/;/ur.../ur.../ur,,.,,.,,.}\
{csym (0,4,7)/(0,2,4,5,7)/(0,4,7)/(0,4,7)/(0,4,7)/(0,4,7)
 cmod ;/;/;/ur.../ur.../ur,,.,,.,,.}\
{csym (7,12,16)/(7,12,16)/(7,12,16)/(7,12,16)/(7,12,16)/(7,12,16)
 cmod ;/;/;/ur.../ur.../ur,,.,,.,,.}\
{csym (0,4,7)/(0,2,4,5,7)/(0,4,7)/(0,4,7)/(0,4,7)/(0,4,7)
 cmod ;/;/;/ur.../ur.../ur,,.,,.,,.}\
{csym (0,4,7)/(0,2,4,5,7)/(0,4,7)/(0,4,7)/(0,4,7)/(0,4,7)
 cmod ;/;/;/ur.../ur.../ur,,.,,.,,.}\
{csym (0,4,7)/(0,2,4,5,7)/(0,4,7)/(0,4,7)/(0,4,7)/(0,4,7)
 cmod ;/;/;/ur.../ur.../ur,,.,,.,,.}\
{csym (7,12,16)/(7,12,16)/(7,12,16)/(7,12,16)/(7,12,16)/(7,12,16)
 cmod ;/;/;/ur.../ur.../ur,,.,,.,,.}\
{csym (0,4,7)/(0,2,4,5,7)/(0,4,7)/(0,4,7)/(0,4,7)/(0,4,7)
 cmod ;/;/;/ur.../ur.../ur,,.,,.,,.}\
{csym (7,12,16)/(7,12,16)/(7,12,16)/(7,12,16)/(7,12,16)/(7,12,16)
 cmod ;/;/;/u.../u.../ur,,.,,.,,.}\
{csym (7,12,16)/(7,12,16)/(7,12,16)/(7,12,16)/(7,12,16)/(7,12,16)
 cmod ;/;/;/u.../u.../ur,,.,,.,,.}\
{csym (7,12,16)/(7,12,16)/(7,12,16)/(7,12,16)/(7,12,16)/(7,12,16)
 cmod ;/;/;/u.../u.../ur,,.,,.,,.}\
{csym (7,12,16)/(7,12,16)/(7,12,16)/(7,12,16)/(7,12,16)/(7,12,16)
 cmod ;/;/u....../u.../u.../ur,,.;,,.}\
{csym (7,12,16)/(7,12,16)/(7,12,16)/(7,12,16)/(7,12,16)/(7,12,16)
 cmod ;/;/u....../u.../u.../ur,,.;,,.}\
{csym (7,12,16)/(7,12,16)/(7,12,16)/(7,12,16)/(7,12,16)/(7,12,16)
 cmod ;/u.''..;''.;.'.'.;;;/u....../u.../u.../ur,,.;,,.}\
{csym (0,4,7)/(0,2,4,5,7)/(0,4,7)/(0,4,7)/(0,4,7)
 cmod ;/r..'.'.'.'./ur....../ur.../ur.../;}\
{csym (7,12,16)/(7,12,16)/(7,12,16)/(7,12,16)/(7,12,16)
 cmod ;/u.;.;''.;.'.'.;;;/ur....../ur.../ur.../;}\
{csym (0,4,7)/(0,2,4,5,7)/(0,4,7)/(0,4,7)/(0,4,7)
 cmod ;/r..'.'.'.'./ur....../ur.../ur.../;}\
{csym (11,14,16)/(11,12,14,16)//(11,14,16)/(11,14,16)/(11,14,16) 
 cmod ;/'.;''.;'.;;'..;'.;/;/u....../u.../u... kybs 41}\
{csym (11,12,14)/(11,12,14,16)//(11,12,14)/(11,12,14)/(11,12,14) 
 cmod ;/'.;''.;'.;;'..;'.;/;/ur'....../ur'.../ur'.../; kybs 41}\
{csym (7,9,12)/(7,9,12)/(7,9,12)/(7,9,12)/(7,9,12)
 cmod ;/ur.;.;''.;'...;;;/ur....../ur.../ur.../;}\
{csym (12,14,16)/(11,12,14,16)/(12,14,16)/(12,14,16)/(12,14,16)
 cmod ;/r''.'.'''...;.;''.;;;/ur....../ur.../ur.../;}\
{csym (12,14,16)/(11,12,14,16)/(12,14,16)/(12,14,16)/(12,14,16)
 cmod ;/;/ur....../ur.../ur.../;}\
{csym (7,9,12)/(7,9,12)/(7,9,12)/(7,9,12)/(7,9,12)
 cmod ;/;/ur....../ur.../ur.../;}\
{csym (11,12,14)/(11,12,14,16)/(11,12,14)/(11,12,14)/(11,12,14)
 cmod ;/;/ur'....../ur'.../ur'.../;}\
{csym (11,14,16)/(11,12,14,16)/(11,14,16)/(11,14,16)/(11,14,16)
 cmod ;/;/u....../u.../u.../;}\
 ;
begin $root "[file rootname [file tail $argv0]]" 0.5;
touch $stem 4;
end $root 0.5;
return;
{csym (7,12,16)/(7,12,16)/(7,12,16)/(7,12,16)        cmod ;/u....../u.../u...}\
{csym (0,2,4,5,7)/(0,4,7)/(0,4,7)/(0,4,7)            cmod ;/ur....../ur.../ur...}\
{csym (7,12,16)/(7,12,16)/(7,12,16)/(7,12,16)        cmod ;/ur....../ur.../ur...}\
{csym (0,2,4,5,7)/(0,4,7)/(0,4,7)/(0,4,7)            cmod ;/ur....../ur.../ur...}\
{csym (11,12,14,16)/(11,14,16)/(11,14,16)/(11,14,16) cmod ;/u....../u.../u...}\
{csym (11,12,14,16)/(11,12,14)/(11,12,14)/(11,12,14) cmod ;/ur'....../ur'.../ur'...}\
{csym (7,9,12)/(7,9,12)/(7,9,12)/(7,9,12)            cmod ;/ur....../ur.../ur...}\
{csym (11,12,14,16)/(12,14,16)/(12,14,16)/(12,14,16) cmod ;/ur....../ur.../ur...}\
