# ----------------------------------------------------------------------------
# Csound Tcl Partitur-Skript   "Dat du min leevsten buest"         NOV-24-2002
# Copyright (c) 2002 by Hartmut Schwarz               matut@matut-spielwerk.de
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2 
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the Free
# Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA 02111-1307, USA.
#
# ----------------------------------------------------------------------------

# ------------------------------------ ins Tcl-Arbeitsverzeichnis wechseln ---
cd "[file dirname $argv0]/..";

# ------------------------------------------- allgemeine Grundlagen lernen ---
source "basics/ref.tcl";   # alles ueber Referenzvariablen
source "basics/tree.tcl";  # alles ueber Datenbaeume

# --------------------------------- die Grundlagen der Csound-Musik lernen ---
source "basics/music.tcl";

# ----------------------------------------------------- special procedures ---

# override the play note procedure so that we can change things whenever a single note is played
# (this must be done whenever we've learned a new instrument and forgot the old one in turn)
proc old_learn_instrument [info args learn_instrument] [info body learn_instrument];
proc learn_instrument { rCTX inam } {
 set crin [old_learn_instrument $rCTX $inam];
 if { $crin != $inam } {
  proc old_instr_play_note [info args instr_play_note] [info body instr_play_note];
  proc instr_play_note { rCTX iocn inum crtv nval when dura volm loud nkey meta csym } {
   set DANCE [TREEget $rCTX DANCE];
   if { $DANCE != "" } {
    $DANCE $rCTX $iocn;
   }
   TREEset $rCTX iazm [TREEget $rCTX AZM$iocn];
   TREEset $rCTX iang [TREEget $rCTX ANG$iocn];
   old_instr_play_note $rCTX $iocn $inum $crtv $nval $when $dura $volm $loud $nkey $meta $csym;
  }
 }
 return $crin;
}

# step to and fro
proc STEP { rCTX iocn } {
 set MIN [TREEget $rCTX STMIN$iocn];
 set MAX [TREEget $rCTX STMAX$iocn];
 set DIR [TREEget $rCTX STDIR$iocn];
 set AZM [expr [TREEget $rCTX AZM$iocn]+$DIR*[TREEget $rCTX STDIF$iocn]];
 if { $AZM <= $MIN } {
  set AZM $MIN;
  TREEset $rCTX STDIR$iocn [expr -1*$DIR];
 } elseif { $AZM >= $MAX } {
  set AZM $MAX;
  TREEset $rCTX STDIR$iocn [expr -1*$DIR];
 }
 TREEset $rCTX AZM$iocn $AZM;
 return;
}

# turn around
proc TURN { rCTX iocn } {
 set ANG [TREEget $rCTX ANG$iocn];
 set DIF [TREEget $rCTX TUDIF$iocn];
 set ANG [expr int($ANG+$DIF)%360]; 
 TREEset $rCTX ANG$iocn $ANG;
 return;
}

# ------------------------------------------------------ das Spiel beginnt ---
set root [plant]; # einen neuen Klangbaum pflanzen
# Dat du min leevsten buest
set stem [TREEnew $root {fstp 1 tmtv 2 \
          idst 150 isze 40 \
          STDIR0   1 STDIR1   1 STDIR2   1 \
          STMIN0 -80 STMIN1 -72 STMIN2 -60 \
          STMAX0  80 STMAX1  72 STMAX2  60 \
          TUDIF0 110 TUDIF1  80 TUDIF2  50 \
          AZM0     0 AZM1    24 AZM2     0 \
          ANG0     0 ANG1     0 ANG2     0}];
sprout $stem\
 {csym {(0,2,4,5,7)/(0,4,7)/(0,4,7)} kybs 17 chbt p./.../f. more {\
   {rept 255 more {\
   {vlbs 76.0 rept 5 more {\
    {cmod ;/u.../u...}\
    {kybs {[expr [STEM kybs]-5]} cmod ;/u.../u...}\
    {cmod ;/u.../u...}\
    {kybs {[expr [STEM kybs]-5]} cmod ;/u.../u...}\
    {kybs {[expr [STEM kybs]+5]} cmod ;/u.../u...}\
   }}\
   {bthk STEP DANCE TURN rept 80 more {\
    {song {} vars {\
     {tmtv 2.0 chbt ./.../f. vlbs 76.0 STDIF2  40 STDIF1  48 STDIF0  60}\
     {tmtv 1.5 chbt ./.../f. vlbs 76.0 STDIF2  40 STDIF1  48 STDIF0  60}\
     {tmtv 1.0 chbt ././f.   vlbs 80.0 STDIF2  80 STDIF1  48 STDIF0 120}\
     {tmtv 1.0 chbt ././f.   vlbs 80.0 STDIF2  80 STDIF1  48 STDIF0 120}\
     {tmtv 2.0 chbt ./.../f. vlbs 76.0 STDIF2  40 STDIF1  48 STDIF0  60}\
    }}\
    {cmod ;/u.../u...}\
    {kybs {[expr [STEM kybs]+5]} cmod ;/u.../u...}\
    {cmod ;/u.../u...}\
    {cmod .'.'./u.../u...}\
    {kybs {[expr [STEM kybs]-5]} cmod r.;*.'.'.;/u.../u...}\
    {cmod .'.'./u.../u...}\
    {kybs {[expr [STEM kybs]-5]} cmod r.;:/u.../u...}\
    {kybs {[expr [STEM kybs]+5]} cmod r*.;''...;/u.../u...}\
    {cmod r''.;''...;/u.../u...}\
    {cmod '.**../u.../u...}\
    {cmod ''.'.;/u.../u...}\
    {kybs {[expr [STEM kybs]+5]} cmod r*.;''...;/u.../u...}\
    {cmod r''.;''...;/u.../u...}\
    {cmod '.**../u.../u...}\
    {cmod ./u.../u...}\
   }}\
  }}\
  {vlbs 76.0 rept 6 more {\
    {cmod ;/u.../u...}\
    {kybs {[expr [STEM kybs]+5]} cmod ;/u.../u...}\
    {cmod ;/u.../u...}\
    {kybs {[expr [STEM kybs]-5]} cmod ;/u.../u...}\
    {cmod ;/u.../u...}\
    {cmod ;/./. chbt ;/._/._}\
  }}\
 }}\
 ;
begin $root "[file rootname [file tail $argv0]]" 0.5;
touch $stem 261;
end $root 0.5;
