# ----------------------------------------------------------------------------
# Csound Tcl Partitur-Skript      "Die Forelle v. Franz Schubert"  APR-02-2003
# Copyright (c) 2003 by Hartmut Schwarz               matut@matut-spielwerk.de
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2 
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the Free
# Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA 02111-1307, USA.
#
# ----------------------------------------------------------------------------

# ------------------------------------ ins Tcl-Arbeitsverzeichnis wechseln ---
cd "[file dirname $argv0]/..";

# ------------------------------------------- allgemeine Grundlagen lernen ---
source "basics/ref.tcl";   # alles ueber Referenzvariablen
source "basics/tree.tcl";  # alles ueber Datenbaeume

# --------------------------------- die Grundlagen der Csound-Musik lernen ---
source "basics/music.tcl";

# ------------------------------------------------------ das Spiel beginnt ---
set root [plant]; # einen neuen Klangbaum pflanzen
# Titel
set stem [TREEnew $root {kybs 12 tmtv 2.0 tvtv 1.05 cstc .05}];
set primo   [TREEnew $stem {crtm 0 vlbs 74.5 iazm -45 iang 180}];
set secondo [TREEnew $stem {crtm 0 vlbs 75.5 iazm  45}];
sprout $primo\
    {csym (17)|(5)                            cmod ;;;.|;;;. section A}\
    {csym (22,22,26,26)|(10,10,14,14)         cmod ....|....}\
    {csym (22,17,17)|(10,5,5)                 cmod .;=.|.;=.}\
    {csym (17,17,24,22,21,19)|(5,5,12,10,9,7) cmod .;;.....|.;;.....}\
    {csym (17)|(5)                            cmod _;:.|_;:.}\
    {csym (22,22,26,26)|(10,10,14,14)         cmod ....|....}\
    {csym (22,17,22)|(10,5,10)                cmod .;=.|.;=.}\
    {csym (21,19,21,22,16)|(9,7,9,10,4)       cmod .;...;.;|.;...;.;}\
    {csym (17)|(5)                            cmod _;:.|_;:.}\
    {csym (21,21,22,21,19,21)|(9,9,10,9,7,9)  cmod .;.;....|.;.;.... section B}\
    {csym (22,17,22)|(10,5,10)                cmod .;=.|.;=.}\
    {csym (21,21,21,27,24,21)|(9,9,9,15,12,9) cmod .;.;....|.;.;....}\
    {csym (22)|(10)                           cmod =;;.|=;;.}\
    {csym (19,19,19,22)|(7,7,7,10)            cmod ....|....}\
    {csym (22,17,17)|(10,5,5)                 cmod .;=.|.;=.}\
    {csym (17,17,24,21)|(5,5,12,9)            cmod .;;..;.;|.;;..;.;}\
    {csym (22,17,14,17)|(10)                  cmod .;;;;...|.;;;;:::  vlbs 75 iazm 45 cres -1}\
    {csym (15,15,19,12,17)|(4,7,10)           cmod .:::....|;...::::  vlbs 75 iazm 45 section C}\
    {csym (14,12,17,14,17)|(2,5,10)           cmod .:::....|;...::::  vlbs 75 iazm 45}\
    {csym (12,16,21,17,24)|(5,9,12)           cmod .:::....|;...::::  vlbs 75 iazm 45}\
    {csym (14,22,17)|(5,10,14,10,14,17)       cmod ,.:::.:::|;...:... vlbs 75 iazm 45}\
    {csym (22,26)|(10,14)                     cmod .|. chbt .|. iazm 45}\
    ;
sprout $secondo\
    {csym (-7,-2,2,-7)|(-14)                  cmod :.,..:.,..|.:.: section A}\
    {csym (-7,-2,2,-7)|(-14)                  cmod :.,..:.,..|.:.:}\
    {csym (-7,-2,2,-7)|(-14)                  cmod :.,..:.,..|.:.:}\
    {csym (-7,-3,4,-7)|(-19)                  cmod :.,..:.,..|.:.:}\
    {csym (-7,-3,4,-7)|(-19)                  cmod :.,..:.,..|.:.:}\
    {csym (-7,-2,2,-7)|(-14)                  cmod :.,..:.,..|.:.:}\
    {csym (-7,-2,2,-7)|(-14)                  cmod :.,..:.,..|.:.:}\
    {csym (-7,-3,0,-7,-8,-2,0,-8)|(-12,-24)   cmod :.,..:.,..|.:.:}\
    {csym (-7,-3,0,-7)|(-19)                  cmod :.,..:.,..|.:.:}\
    {csym (-7,-3,4,-7)|(-19)                  cmod :.,..:.,..|.:.: section B}\
    {csym (-7,-2,2,-7)|(-14)                  cmod :.,..:.,..|.:.:}\
    {csym (-7,-3,4,-7)|(-19)                  cmod :.,..:.,..|.:.:}\
    {csym (-7,-2,2,-7)|(-14)                  cmod :.,..:.,..|.:.:}\
    {csym (-2,3,-2,0,-2,-5,-2)|(-21)          cmod :.......|.:.:}\
    {csym (-7,2,-7,0,-7,2,-7)|(-14)           cmod :.......|.:.:}\
    {csym (-7,-3,-7,3,-7,0,-7)|(-19)          cmod :.......|.:.:}\
    {csym (-7,2,-7,-2)|(-14)                  cmod :.._::.;|.:.: iazm -45 iang 180 vlbs 78 cres 1}\
    {csym (-3,-5,-5,-5,-2,-3,0)|(-21)         cmod .==;.....|..  iazm -45 iang 180 vlbs 78 section C}\
    {csym (-2,-7,-7)|(-14)                    cmod .;=.|:.;;     iazm -45 iang 180 vlbs 78}\
    {csym (-7,-7,0,-3)|(-19)                  cmod .;;..;.;|..   iazm -45 iang 180 vlbs 78}\
    {csym (-2,-7,-2)|(-14)                    cmod .;..|.        iazm -45 iang 180 vlbs 78}\
    {csym (-7,-2,2)|(-14)                     cmod ,,p.|p. chbt ._|._ iazm -45 iang 180 vlbs 78}\
    ;
begin $root "[file rootname [file tail $argv0]]" 0.5;
touch $primo 22;
touch $secondo 22;
end $root 1.0;
